;---------------------------------------------------------------------------
;
;			MBR -- Master Boot Record Structures
;
;---------------------------------------------------------------------------

; Partition System Indicators

SYS_ID_FAT12		EQU	01h
SYS_ID_FAT16		EQU	04h
SYS_ID_EXTDOS		EQU	05h
SYS_ID_BIGDOS		EQU	06h
SYS_ID_HPFS		EQU	07h
SYS_ID_NTFS		EQU	07h
SYS_ID_OS2_BOOT_MGR	EQU	0Ah
SYS_ID_BIGDOS_FAT32	EQU	0Bh
SYS_ID_BIGDOS_FAT32x	EQU	0Ch
SYS_ID_BIGDOS_INT13x	EQU	0Eh
SYS_ID_EXTDOS_INT13x	EQU	0Fh

; Misc

MBR_MAGIC_POS		EQU	512 * 01h - 2
EXT_MAGIC_POS		EQU	512 * 02h - 4

MBR_TABLE_POS		EQU	01BEh
MBR_TABLE_MAX		EQU	4
MBR_ENTRY_BOOTABLE	EQU	80h
MBR_ENTRY_INACTIVE	EQU	00h

; Partition Table Placement

MBR_TABLE_HERE MACRO
	ORG	MBR_TABLE_POS
	ENDM

; Signature Placement

MBR_MAGIC_HERE MACRO ???Num
	ORG	MBR_MAGIC_POS
	DW	0AA55h
	ENDM

EXT_MAGIC_HERE MACRO ???Num
	ORG	EXT_MAGIC_POS
	DD	0AA55BEEFh
	ENDM

END_MAGIC_HERE MACRO ???Num
	ORG	END_MAGIC_POS
	DD	0AA55DEADh
	ENDM

; MBR -- Master Boot Record -- Partition Entry

MBR_ENTRY		STRUC
mbrBootFlag		DB	?
mbrStartHead		DB	?
mbrStartCylinderSector	DW	?
mbrSystemID		DB	?
mbrEndHead		DB	?
mbrEndCylinderSector	DW	?
mbrPartitionStart	DD	?
mbrPartitionSize	DD	?
MBR_ENTRY		ENDS

