;---------------------------------------------------------------------------
;
;		      32-bit PM Kernel Debugger Helper
;
;     Copyright (c) 1999-2001 by Thomas Kjoernes, all rights reserved.
;
;---------------------------------------------------------------------------

	INCLUDE std.inc
	INCLUDE stdgroup.inc

	.386p

	; Publics

	PUBLIC	kdbWriteChar
	PUBLIC	kdbBlockChar
	PUBLIC	kdbWriteMsgZ

	; Startup/Shutdown

	PUBLIC	kdbInit
	PUBLIC	kdbDone

codeSegment SEGMENT

	; Externs

;---------------------------------------------------------------------------
;	kdbWriteChar - 
;
;	Entry:
;		al = character
;		ah = attribute
;		cl = X
;		dl = Y
;	Exit:
;		None
;
DefProc kdbWriteChar

	push	ecx
	push	edx

	and	ecx, 0FFh	; 
	shl	ecx, 1		; X * 2
	and	edx, 0FFh	; Y
	add	ecx, 0B8000h	;
	shl	edx, 5		; Y * 32
	add	ecx, edx	;
	shl	edx, 2		; Y * 128
	add	ecx, edx	;

	mov	WORD PTR [ecx], ax

	pop	edx
	pop	ecx
	ret

EndProc kdbWriteChar

;---------------------------------------------------------------------------
;	kdbBlockChar - 
;
;	Entry:
;		al = character
;		ah = attribute
;		cl = X
;		ch = Width
;		dl = Y
;		dh = Height
;	Exit:
;		None
;
DefProc kdbBlockChar

	push	ebx
	push	ecx
	push	edx

	mov	ebx, ecx

kdbBlockCharNext:
	call	kdbWriteChar
	inc	cl
	dec	ch
	jnz	kdbBlockCharNext

	mov	ecx, ebx

	inc	dl
	dec	dh
	jnz	kdbBlockCharNext

	pop	edx
	pop	ecx
	pop	ebx
	ret

EndProc kdbBlockChar

;---------------------------------------------------------------------------
;	kdbWriteMsgZ - 
;
;	Entry:
;		None
;	Exit:
;		None
;
DefProc kdbWriteMsgZ

	push	eax
	push	ecx
	push	esi

	cld

kdbWriteMsgZNext:
	lodsb
	test	al, al
	jz	kdbWriteMsgZExit

	call	kdbWriteChar
	inc	cl
	jmp	kdbWriteMsgZNext

kdbWriteMsgZExit:
	pop	esi
	pop	ecx
	pop	eax
	ret

EndProc kdbWriteMsgZ

;---------------------------------------------------------------------------
;	kdbInit - 
;
;	Entry:
;		None
;	Exit:
;		None
;
DefProc kdbInit
	ret
EndProc kdbInit

;---------------------------------------------------------------------------
;	kdbDone - 
;
;	Entry:
;		None
;	Exit:
;		None
;
DefProc kdbDone
	ret
EndProc kdbDone

codeSegment ENDS

;---------------------------------------------------------------------------
; Data
;---------------------------------------------------------------------------

dataSegment SEGMENT

dataSegment ENDS

;---------------------------------------------------------------------------
; BSS Data
;---------------------------------------------------------------------------

bssSegment SEGMENT

bssSegment ENDS

	END

